blog/urls.py
from django.urls import path
from . import views

app_name = 'blog'

urlpatterns = [
    # post views
    path('', views.post_list, name='post_list'),
#     path('', views.PostListView.as_view(), name='post_list'),
    path('<int:year>/<int:month>/<int:day>/<slug:post>/',
         views.post_detail,
         name='post_detail'),
    path('<int:post_id>/share/', views.post_share, name='post_share'),
    path('<int:post_id>/comment/',
         views.post_comment, name='post_comment'),
    path('post/create/', views.post_post, name='post_create'),
    path('tag/<slug:tag_slug>/', views.post_list, name='post_list_by_tag'),
    path('publish_draft_posts/', views.publish_draft_posts, name='publish_draft_posts')
]

mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('blog/', include('blog.urls', namespace='blog'))
]

blog/models.py
from django.db import models
from django.utils import timezone
from django.contrib.auth.models import User, AnonymousUser
from django.urls import reverse


from taggit.managers import TaggableManager

class PublishedManager(models.Manager):
    def get_queryset(self):
        return super().get_queryset()\
        .filter(status=Post.Status.PUBLISHED)

class Post(models.Model):

    class Status(models.TextChoices):
        DRAFT = 'DF', 'Draft'
        PUBLISHED = 'PB', 'Published'

    title = models.CharField(max_length=250)
    slug = models.SlugField(max_length=250,
                            unique_for_date='publish')
    author = models.ForeignKey(User,
                               on_delete=models.CASCADE,
                               related_name='blog_posts')
    body = models.TextField()
    publish = models.DateTimeField(default = timezone.now)
    created = models.DateTimeField(auto_now_add=True)
    updated = models.DateTimeField(auto_now_add=True)
    status = models.CharField(max_length=2,
                              choices=Status.choices,
                              default=Status.DRAFT)
    

    objects = models.Manager() # The default manager.
    published = PublishedManager() # Our custom manager.

    tags = TaggableManager()

    class Meta:
        ordering = ['-publish']
        indexes = [
            models.Index(fields=['-publish'])
        ]

    def __str__(self):
        return self.title
    
    def get_absolute_url(self):
        # reverse construit dynamiquement l'URL
        return reverse('blog:post_detail',
                       args=[
                           self.publish.year,
                           self.publish.month,
                           self.publish.day,
                           self.slug
                           ])


class Comment(models.Model):
    post = models.ForeignKey(Post,
                             on_delete=models.CASCADE,
                             related_name='comments')
    name = models.CharField(max_length=80)
    email = models.EmailField()
    body = models.TextField()
    created = models.DateTimeField(auto_now_add=True)
    updated = models.DateTimeField(auto_now=True)
    active = models.BooleanField(default=True)

    class Meta:
        ordering = ['created']
        indexes = [
            models.Index(fields=['created']),
        ]
    def __str__(self):
        return f'Comment by {self.name} on {self.post}'

    def get_absolute_url(self):
        return reverse('blog:post_comment',
                       args=[self.post.id])

blog/forms.py
from django import forms
from django.shortcuts import get_object_or_404
from .models import Comment, Post, User

from django.urls import reverse_lazy
from django.utils.text import slugify
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Submit
from crispy_forms.layout import Layout, Row, Field

from taggit.managers import TaggableManager

class EmailPostForm(forms.Form):

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.helper = FormHelper(self)
        self.helper.add_input(Submit('submit', 'Send e-mail'))
        self.helper.form_show_errors = True
        self.helper.layout = Layout(
            Row(
                Field('name', wrapper_class='col-md-2'),
                Field('email', wrapper_class='col-md-2'),
            ),
            Row(
                Field('to', wrapper_class='col-md-2'),
            ),
            Row(
                Field('comments', wrapper_class='col-md-2'),
            )
        )

    name = forms.CharField(max_length=25, label="name")
    email = forms.EmailField(label="email")
    to = forms.EmailField(label="to")
    comments = forms.CharField(required=False,
                               widget=forms.Textarea(attrs={'placeholder':'Your comment goes here'}),
                               label="comment",)


class CommentFormCrispy(forms.Form):

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

        self.helper = FormHelper(self)
        self.helper.form_action = reverse_lazy('blog:post_comment')
        self.helper.add_input(Submit('submit', 'Submit'))
        self.helper.form_show_errors = True

    post_id = forms.IntegerField(widget=forms.HiddenInput)
    body = forms.CharField(
        widget=forms.Textarea(attrs={'placeholder':'Add comment'})
    )

    def save(self):
        cleaned_data = self.cleaned_data

        body = cleaned_data['body']
        print("cleaned data: ", cleaned_data)
        post_id = cleaned_data['post_id']

        post = get_object_or_404(Post, id=post_id, status=Post.Status.PUBLISHED)
        print("post", post)

        try:
            comment = Comment.objects.create(
                post = post,
                name =  ' '.join(body.split()[:5]) + " ..." , # on prend les 5 premiers mots du commentaire
                email = 'example@gmail.com',
                body = body,
            )
            return comment
        
        except:
            # envoyer une erreur 404
            pass


class CommentForm(forms.ModelForm):
    body = forms.CharField(label="",
                           widget=forms.Textarea(attrs={'placeholder':'Your comment goes here'}))

    class Meta:
        model = Comment
        fields = [ 'body']



class PostForm(forms.Form):

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.helper = FormHelper(self)
        self.helper.form_action = reverse_lazy('blog:post_create')
        self.helper.add_input(Submit('submit', 'Submit'))
        self.helper.form_show_errors = True
        self.helper.layout = Layout(
            Row(
                Field('title', wrapper_class='col-md-9'),
                Field('author', wrapper_class='col-md-2'),
            ),
            Row(
                Field('body')
            ),
            Row(
                Field('status', wrapper_class='col-md-4'),
                Field('tags', wrapper_class='col-md-7')
            )
        )

    title = forms.CharField(label="title")
    author = forms.ChoiceField(choices=[
            (user.id, user.username) for user in User.objects.all()
        ],
        widget=forms.Select(),
        initial=1,
        label="author"
    )
    body = forms.CharField(
        widget=forms.Textarea(attrs={'placeholder':'Your post goes here'}),
        label="body"
    )
    status = forms.ChoiceField(choices=
        ((1, 'Draft'),
        (2, 'Published'),),
        widget=forms.RadioSelect(),
        initial=1,
        label="status"
    )
    tags = forms.CharField(
        required=False, help_text="Separate tags with a comma",
        label="tags"
    )

    def save(self):
        cleaned_data = self.cleaned_data
        
        title = cleaned_data['title']
        author = User.objects.get(pk=cleaned_data['author'])
        body = cleaned_data['body']
        status = ['DF', 'PB'][int(cleaned_data['status'])-1]
        tags = cleaned_data['tags'].split(',')

        post = Post.objects.create(
            title=title,
            slug=slugify(title),
            author=author,
            body=body,
            status=status,
            tags=tags
        )

        return post

blog/views.py
from django.shortcuts import render, get_object_or_404
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger
from django.urls import reverse
from django.http import HttpResponseRedirect
from .models import Post, Comment, AnonymousUser


from django.views.generic import ListView

from .forms import EmailPostForm, CommentForm, PostForm, CommentFormCrispy
from django.core.mail import send_mail

from django.views.decorators.http import require_POST

from taggit.models import Tag

from django.db.models import Count


def post_list(request, tag_slug=None):
    post_list = Post.published.all()
    comment_dict = dict() # dictionnaire -> post, ses commentaires

    print("tag slug: ", tag_slug)

    tag = None
    if tag_slug:
        tag = get_object_or_404(Tag, slug=tag_slug)
        post_list = Post.published.filter(tags__name__in=[tag.name])

    paginator = Paginator(post_list, 3) # 3 Posts par page
    page_number = request.GET.get('page', 1)

    try:
        posts = paginator.page(page_number)
    except EmptyPage:
        posts = paginator.page(paginator.num_pages) # page max
    except PageNotAnInteger:
        posts = paginator.page(1)

    for post in post_list:
        comment_dict[post] = post.comments.filter(active=True)

    # on récupère 3 posts du user courant
    if request.user.is_authenticated:
        post_user = Post.published.filter(author=request.user)[:3]
    else:
        post_user = None

    # les formulaires
    form_post = PostForm()
    form_comment = CommentForm()


    return render(request,
                  'blog/post/list.html',
                  {'user':request.user,
                   'post_user':post_user,
                   'posts': posts,
                   'tag': tag,
                   "comment_dict":comment_dict,
                   'form_post':form_post,
                   'form_comment':form_comment})



def post_detail(request, year, month, day, post):
    post = get_object_or_404(Post,
                             slug=post,
                             publish__year=year,
                             publish__month=month,
                             publish__day=day)

    comments = post.comments.filter(active=True)
    form_comment = CommentForm()

    # posts similaires
    post_tags_ids = post.tags.values_list('id', flat=True)

    similar_posts = Post.published.filter(tags__in=post_tags_ids)\
        .exclude(id=post.id)
    similar_posts = similar_posts.annotate(same_tags=Count('tags'))\
        .order_by('-same_tags','-publish')[:4]

    return render(request,
                  'blog/post/detail.html',
                  {'post': post,
                   'comments': comments,
                   'form_comment': form_comment,
                   'similar_posts':similar_posts,
                   "user": request.user})



def post_share(request, post_id):
    post = get_object_or_404(Post, id=post_id, status=Post.Status.PUBLISHED)
    sent = False

    # si le formulaire est envoyé
    if request.method == 'POST':
        form = EmailPostForm(request.POST)
        if form.is_valid():
            cd = form.cleaned_data
            post_url = request.build_absolute_uri(
            post.get_absolute_url())
            subject = f"{cd['name']} recommends you read " \
                f"{post.title}"
            message = f"Read {post.title} at {post_url}\n\n" \
                f"{cd['name']}\'s comments: {cd['comments']}"
            send_mail(subject, message, 'bernardi.vincent28@gmail.com',
                [cd['to']])
            sent = True
    else:
        form = EmailPostForm()
    return render(request, 'blog/post/share.html', {'post': post,
                                                    'form': form,
                                                    "sent": sent})



def post_comment_crispy(request):
    post = None
    comment = None
    form_comment = CommentForm(data=request.POST)

    if form_comment.is_valid():
        comment = form_comment.save()
        comment.save()

        post = comment.post

    return render(request, 'blog/post/comment.html',
                  {'post': post,
                   'form_comment': form_comment,
                   'comment': comment})


def post_comment(request, post_id):
    post = get_object_or_404(Post, id=post_id, status=Post.Status.PUBLISHED)
    comment = None
    form_comment = CommentForm(data=request.POST)

    if form_comment.is_valid():
        comment = form_comment.save(commit=False)
        comment.post = post
        comment.name = request.user.username
        comment.email = 'example@gmail.com',
        comment.save()

    return render(request, 'blog/post/comment.html',
                  {'post': post,
                   'form_comment': form_comment,
                   'comment': comment})



def post_post(request):
    form_post = PostForm(data=request.POST)
    form_comment = CommentForm()
    print("form post", form_post)
    post = None
    if form_post.is_valid():
        post = form_post.save()
        post.save()
        # pour sauvegarder les tags
        # form_post.save_m2m()
    return render(request,
                  'blog/post/detail.html',
                  {'post': post,
                   'form_post':form_post,
                   'form_comment':form_comment})


def publish_draft_posts(request):
    list_posts = request.POST.getlist('posts')
    for post_id in list_posts:
        post = Post.objects.get(id=post_id)
        post.status = 'PB'
        post.save()

    return HttpResponseRedirect(reverse('blog:post_list'))

blog/templates/blog/post/comment.html
{% extends "base.html" %}

{% block content %}

    {% if comment %}
        <p><a href="{{ post.get_absolute_url }}">Go to the post</a></p>
        <p><a href="http://127.0.0.1:8000/blog/?page=1">Back to the list</a></p>

        <b>
            {{ comment.name }}
        </b> - 
        <em>
            {{ comment.created }}
        </em>
        <p class="bg-body-highlight">
            {{ comment.body }}
        </p>
    {% else %}
        {% include "blog/post/includes/comment_form.html" %}
    {% endif %}

{% endblock %}

blog/templates/blog/post/detail.html
{% extends "base.html" %}

{% load blog_tags %}

{% load static %}

{% block content %}

<!-- si on ne se trouve pas sur la liste des posts -->
{% if not form_post %}
    <h3 class="mb-6">
        <a href="http://127.0.0.1:8000/blog/?page=1">Back to the list</a>
    </h3>
{% endif %}

<div class="card mb-5">

   <!-- auteur et titre du post -->
   <div class="card-header position-relative">

        <h2 class="mb-3">
            <a href="{{ post.get_absolute_url }}">
                {{ post.title }}
            </a>
        </h2>

        <div class="d-flex align-items-center mb-3">
            <div class="avatar avatar-xl  me-2">
                <img class="rounded-circle" src="{% static "assets/img/team/" %}{{ post.author_id }}.webp" alt="image user">
            </div>
            <div class="flex-1">
                <p class="fw-bold mb-0 text-body-emphasis">
                    {{ post.author }}
                </p>
                <p class="fs-9 mb-0 text-body-tertiary text-opacity-85 fw-semibold">
                    {{ post.publish }}
                </p>
            </div>

        </div>
        
        
    </div>


    <!-- tags et contenu du post -->
    <div class="card-body p-3 p-sm-4">

        <p>
            Tags:
            
            {% for tag in post.tags.all %}
                <a href="{% url "blog:post_list_by_tag" tag.slug %}#top-post">
                    {{ tag.name }}
                </a>
                {% if not forloop.last %}, {% endif %}
            {% empty %}
                <a> No tag </a>
            {% endfor %}
            
        </p>
        
        <div class="bg-body-secondary p-sm-3">
            {{ post.body|markdown|truncatewords_html:150 }}
        </div>


        <div class="mt-2">
            <h3 >
                <a href="{% url "blog:post_share" post.id %}">
                    Share this post
                </a>
            </h3>
        </div>

        <div class="mt-2">
            <h2>Similar posts</h2>
            
            {% for post in similar_posts %}
            <p>
                <a href="{{ post.get_absolute_url }}">{{ post.title }}</a>
            </p>
            {% empty %}
                There are no similar posts yet.
            {% endfor %}
        </div>


    </div>



    <!-- commentaires -->
    <div class="border-top border-translucent p-3 p-sm-4">

        {% for comment in comments %}

            {% if comment.name %}
                <b>
                    {{ comment.name }}
                </b>
            {% else %}
                <b>
                    Anonyme
                </b>
            {% endif %}
            <p class="fs-9 mb-0 text-body-tertiary text-opacity-85 fw-semibold">
                {{ comment.created|date:"d  F  Y - P" }}
            </p>
            <p class="bg-body-highlight">
                {{ comment.body }}
            </p>
        {% empty %}
            <p> There are no comments. </p>
            
        {% endfor %}

        <div class="d-flex align-items-center">

            {% include "blog/post/includes/comment_form.html" %}

        </div>

    </div>

</div>

{% endblock %}

blog/templates/blog/post/latest_comments.html
<ul>
    {% for comment in latest_comments %}
        <li>
            {% if comment.name %}
                <b>
                    {{ comment.name }}
                </b>
            {% else %}
                <b>
                    Anonyme
                </b>
            {% endif %}
                
                <p class="fs-9 mb-0 text-body-tertiary text-opacity-85 fw-semibold">
                        {{ comment.created|date:"d  F  Y - P" }}
                </p>
                <p class="bg-body-highlight">
                    {{ comment.body }}
                </p>
            
        </li>
    {% endfor %}
</ul>

blog/templates/blog/post/latest_posts.html
<ul>
    {% for post in latest_posts %}
        <li>
            <a href="{{ post.get_absolute_url }}">{{ post.title }}</a>
        </li>
    {% endfor %}
</ul>

blog/templates/blog/post/list.html
{% extends "base.html" %}

{% load blog_tags %}

{% load static %}

{% block title %}My Blog{% endblock %}

{% block content %}


    <div class="pb-10">

        <div class="row justify-content-md-center">
            
            <!-- visualisation user et données blog -->
            <div class="col col-lg-4">
                
                <!-- visualisation du user -->
                <div class="card mb-5">

                    <div class="card-header position-relative mb-7 " style="min-height: 150px; ">

                        <div class="bg-holder rounded-top" style="background-image: linear-gradient(0deg, #000000 -3%, rgba(0, 0, 0, 0) 23%), url(../../../../static/assets/img/generic/11.jpg)">
                        </div>
                        <label class="avatar avatar-4xl feed-avatar-profile cursor-pointer">
                            {% if user.is_authenticated %}
                                <img class="rounded-circle img-thumbnail shadow-sm border-0" src="{% static "assets/img/team/" %}{{ user.id }}.webp" alt="image user">
                            {% else %}
                                <img class="rounded-circle img-thumbnail shadow-sm border-0" src="{% static "assets/img/team/avatar.webp" %}" alt="image user">
                            {% endif %}
                        </label>

                    </div>


                    <div class="card-body">

                        <div class="avatar avatar-name">
                            <h3 class="w-bold mb-0 text-body-emphasis">
                                {% if user.is_authenticated %}
                                    {{ user.username|lower|capfirst }}
                                {% else %}
                                    unauthenticated user
                                {% endif %}
                            </h3>
                        </div>

                    </div>


                    <div class="card-footer">
                        
                            {% if user.is_authenticated %}

                                <!-- afficher 3 posts du user -->
                                <div>
                                    Some of my posts :
                                    <p></p>
                                    <ul>
                                        {% for post_u in post_user %}
                                        <li>
                                            <a href="{{ post_u.get_absolute_url }}">
                                                {{ post_u.title }}
                                            </a>
                                        </li>
                                        {% endfor %}
                                    </ul>
                                </div>

                                <!-- permettre de publier des posts en status 'brouillon' ( DF => PB ) -->
                                <div>
                                    Publish draft posts :
                                    <p></p>
                                    {% publish_draft_posts user %}

                                </div>

                            {% else %}
                                <input class="btn btn-primary px-6 px-sm-8" type="submit" value="Sign In">
                            {% endif %}

                    </div>
                       

                <!-- fin card mb-5 -->
                </div>


                <!-- visualisation des données du blog -->
                <div class="card mb-5">


                    <div class="card-header">

                        <h3>Latest posts</h3>
                        {% show_latest_posts 4 %}

                    </div>

                    
                    <div class="card-body mb-4">

                        <h3> Latest comments </h3>
                        {% show_latest_comments 5 %}
                        

                    </div>


                </div>
                    
            <!-- fin visualisation user et données blog -->
            </div>
            
            
            <!-- visualisation des posts -->
            <div class="col-lg-7">
                
                <!-- formulaire pour créer un post -->
                <div>
                    {% include "blog/post/includes/post_form.html" %}
                </div>
                

                <!-- balise invisible pour recentrer sur les posts -->
                
                {% if tag %}
                <h4 class="mt-7">
                    <a> Tag : {{ tag }} </a> -
                    <a href="{% url 'blog:post_list' %}"> Cancel tag filter </a>
                </h4>
                {% endif %}

                <a id="top-post"></a>
                
                <!-- affichage des posts -->
                {% for post, comments in comment_dict.items %}
                
                    {% include 'blog/post/detail.html' %}
                    
                {% endfor %}
                
                
                {% include "pagination.html" with page=posts %}
                
                <!-- fin visualisation posts -->
            </div>
            
            <!-- fin ligne -->
        </div> 
        
        <!-- pb 10 -->
    </div>

    <a  href="#top-page"
        class="btn p-0 btn-support-chat bg-info"
        style="position: fixed; bottom: 50px; right: 10px;"
        >
        <span class="fs-3 btn-text text-white"> ⌃ </span>
    </a>
        
{% endblock %}

blog/templates/blog/post/publish_draft_posts.html
<ul>
    <form action="{% url 'blog:publish_draft_posts' %}" method="POST">

        {% csrf_token %}

        {% for post in draft_posts %}
            <li>
                <a href="{{ post.get_absolute_url }}">{{ post.title }}</a>
                <input type="checkbox" name="posts" id="post-{{ post.id }}" value="{{ post.id }}">

            </li>
        {% empty %}
            <em> No draft post yet</em>
        {% endfor %}

        {% if draft_posts|length > 0 %}
            <input id="publish-button" class="btn btn-primary btn-sm px-6 px-sm-8" type="submit" value="Publish" disabled>
        {% endif %}
        <script>
            // pour activer ou non le bouton
            const checkboxInputs = Array.from(document.querySelectorAll('input[type="checkbox"][name="posts"]'));
            const publishButton = document.getElementById('publish-button');

            checkboxInputs.forEach(checkbox => {
            checkbox.addEventListener('change', () => {
                const anyChecked = checkboxInputs.some(checkbox => checkbox.checked);
                publishButton.disabled = !anyChecked;
            });
            });
          </script>

    </form>
</ul>

blog/templates/blog/post/share.html
{% extends "base.html" %}

{% block title %}Share a post{% endblock %}

{% load crispy_forms_tags %}

{% block content %}

    {% if sent %}
        <h1>E-mail successfully sent</h1>
        <p>
            "{{ post.title }}" was successfully sent to {{ form.cleaned_data.to }}.
        </p>
    {% else %}
        <h1>Share "{{ post.title }}" by e-mail</h1>

        {% crispy form %}
        
    {% endif %}
    
{% endblock %}